#!/usr/bin/perl

use File::Path;
use File::Copy;
use File::Glob ":glob";
use POSIX ":sys_wait_h";

$timeout = 60;

$ENV{HOME}="/root";
$ENV{TMP}="/tmp";
$ENV{MOZILLA_FIVE_HOME}="/usr/lib/mozilla-firefox-2.0.0.11";
$ENV{LD_LIBRARY_PATH}="/usr/lib/mozilla-firefox-2.0.0.11";
$ENV{MOZ_DISABLE_GNOME}="1";

umask 022;

if ( -f "/usr/lib/mozilla-firefox-2.0.0.11/mozilla-firefox-bin" )
{
    # change cache date to cause it to be dirty 
    unlink </usr/lib/mozilla-firefox-2.0.0.11/components/*.dat>;

    # Register firefox
    $pid = fork();

    # I am the child.
    if ($pid == 0) {
	exec("/usr/lib/mozilla-firefox-2.0.0.11/mozilla-firefox-bin -register> /dev/null 2> /dev/null");
    }
    # I am the parent.
    else {
	my $timepassed = 0;
	do {
	    $kid = waitpid($pid, &WNOHANG);
	    sleep(1);
	    $timepassed++;
        } until $kid == -1 || $timepassed > $timeout;

	# should we kill?
	if ($timepassed > $timeout) {
	    kill (9, $pid);
	    # kill -9 can leave threads hanging around
            system("/usr/bin/killall -9 /usr/lib/mozilla-firefox-2.0.0.11/mozilla-firefox-bin");
	}
    }
}



